#include <stdio.h>
#include <stdlib.h>	// malloc
#include <string.h>
#include <ctype.h>
#include <setjmp.h>
#include <sys/stat.h>
//#include <libgyl.h>
#include "htmfa.h"

static jmp_buf jmpbuf;
struct htmstr gyoker;

static char *foglal(int meret);
static struct nodestr *ujnod(struct htmstr *nod);
static char *optolt(struct tagstr *tagmut,char *mut);
static void strlwr(char *mut);


struct htmstr *htmfa(char *fnev)
{
FILE *fp;
struct stat fmunka;
char *puffer,*mut,*m;
int c;
struct htmstr *aktnod;
struct nodestr *nodemut;
static const char kommkezd[] = "<!--", kommveg[] = "-->";
static const int	kommkhossz = sizeof(kommkezd)-1, 
			kommvhossz = sizeof(kommveg)-1;

gyoker.darab = 0; gyoker.ag = NULL; gyoker.szulo = NULL;
fp = puffer = NULL;
switch(c=setjmp(jmpbuf))
	{	// 0: nincs hiba
	case FILEHIBA:
		fprintf(stderr,"I/O hiba: %s\n",fnev);
		break;
	case MEMHIBA:
		fprintf(stderr,"Kicsi a memoria\n");
		break;
	}	
if(c)	{
	if(fp != NULL)
		fclose(fp);	// memoriafelszabaditas!
	if(puffer != NULL)
		free(puffer);
	return(NULL);
	}

	// A teljes file beolvasasa a memoriaba
if( (fp = fopen(fnev,"r")) == NULL || fstat(fileno(fp),&fmunka))
	longjmp(jmpbuf,FILEHIBA);
puffer = foglal(fmunka.st_size+2);
if(fread(puffer,1,fmunka.st_size,fp) < fmunka.st_size)
	longjmp(jmpbuf,MEMHIBA);
puffer[fmunka.st_size] = puffer[fmunka.st_size+1] = 0;
fclose(fp); fp = NULL;	// ujnode()-ban meg lehet memoriahiba

for(mut=puffer, aktnod = &gyoker; *mut; )
	{
	enum htmlkod kod;
	
	if(*mut == '<' && mut[1] != '/')
		{
		char *m;

		m = mut+1;
		kod = tagkeres(&m);
		}
	if(*mut == '<' && mut[1] != '/' && kod != VEGE)
		{	// htm tag jott. Uj node-ot csinalunk neki.
		struct tagstr *tagmut;

		nodemut = ujnod(aktnod);
		nodemut->szov = NULL;

		tagmut = nodemut->tag = 
			(struct tagstr *)foglal(sizeof(struct tagstr));
		mut = optolt(tagmut,mut)+1;	// ugras > utanra
		tagmut->kod = kod;
		if(tagmut->kod != VEGE && 
				tagtomb[tagmut->kod].flag.zaro == NINCS)
			tagmut->node = NULL;	// nem lehet zaro tag
		else	{
			tagmut->node = 
				(struct htmstr *)foglal(sizeof(struct htmstr));
			tagmut->node->szulo = aktnod;
			aktnod = tagmut->node;
			aktnod->darab = 0;
			aktnod->ag = NULL;
			}
		tagmut->zaroflg = 0;
//		mut += c+1;	// ugras > utanra
		}
	if(*mut == '<' && mut[1] == '/')
		{	// htm tag lezaras jott
		char *m;
		struct htmstr *szulo;

		m = mut+2;
		kod = tagkeres(&m);
		for(szulo=aktnod; (szulo=szulo->szulo) != NULL; )
			{
			nodemut = szulo->ag[szulo->darab-1];
			if(szulo->darab && nodemut->tag != NULL &&
			   nodemut->tag->kod == kod && 
			   nodemut->tag->zaroflg == 0)
				{
				nodemut->tag->zaroflg = 1;
				aktnod = szulo;
				break;
				}
			}
		mut += strcspn(mut,">") + 1;
		}
	if(*mut != '<' || kod == VEGE)
		{	// nem/ismeretlen htm tag jott
		struct szovegstr *szovmut;
		struct charstr *charmut;

		nodemut = ujnod(aktnod);
		nodemut->tag = NULL;

		szovmut = nodemut->szov = 
			(struct szovegstr *)foglal(sizeof(struct szovegstr));
		szovmut->darab=1;
		szovmut->txt = 
			(struct charstr **)foglal(sizeof(struct charstr *));
		charmut = *szovmut->txt = 
			(struct charstr *)foglal(sizeof(struct charstr));
		if(memcmp(mut,kommkezd,4))
			{	// Nem HTML-comment
			charmut->tip = SZOVEG;
			c = strcspn(mut+1,"<") + 1;	// < lehet elso kar.
			}
		else	{	// HTML-comment
			charmut->tip = COMMENT;
			mut += kommkhossz;
			m = strstr(mut,kommveg);
			c = m == NULL? strlen(mut): m-mut;
			}
		charmut->cim = foglal(c+1);
		memcpy(charmut->cim,mut,c);
		charmut->cim[c] = 0;
		mut += c;
		if(charmut->tip == COMMENT && m != NULL)
			mut += kommvhossz;
		}
	}
fprintf(stderr,"%s, %ld byte\n",fnev,(long)fmunka.st_size);
free(puffer);	// gyoker-t a hivo szabaditja fel, amint vegzett.
return(NULL);
}



static char *foglal(int meret)
{
char *ret;

if( (ret = malloc(meret)) == NULL)
	longjmp(jmpbuf,MEMHIBA);
return(ret);
}



static struct nodestr *ujnod(struct htmstr *nod)
{
if( (nod->ag = realloc(nod->ag,(nod->darab+1)*
			sizeof(struct nodestr *))) == NULL)
	longjmp(jmpbuf,MEMHIBA);
return nod->ag[nod->darab++] = (struct nodestr *)foglal(sizeof(struct nodestr));
}



static char *optolt(struct tagstr *tagmut,char *mut)
{	// mut a < jellel kezdodo tag cime. A > cimet adja vissza.
static const char sep[] = "> \t\r\n";	// opcio szeparalo karakterek
struct opciostr *op;
int h;

tagmut->optszam = 0;
tagmut->optomb = NULL;
//return mut + strcspn(mut,">");	// ha nem akarunk opciokat
while(mut += strcspn(mut,sep), mut += strspn(mut,sep+1), *mut != '>')
	{	// mut a kovetkezo opciora mutat
	if( (tagmut->optomb = realloc(tagmut->optomb,(tagmut->optszam+1)*
			sizeof(struct opciostr *))) == NULL)
		longjmp(jmpbuf,MEMHIBA);
	op = tagmut->optomb[tagmut->optszam++] = 
			(struct opciostr *)foglal(sizeof(struct opciostr));
	h = strcspn(mut,"=>");
	op->nev = foglal(h+1);
	if(h)
		memcpy(op->nev,mut,h);
	op->nev[h]=0;
	strlwr(op->nev);
	if(mut[h] == '=')
		h = strcspn(mut += h+1,sep);
	else	mut += h, h = 0;	// a nev utan nincs =
	if(*mut == '\"')
		h = strcspn(++mut,"\"");	// " kozott > lehet?
	op->opcio = foglal(h+1);
	if(h)
		memcpy(op->opcio,mut,h);
	op->opcio[h]=0;
	mut += h;	// akkor kell, ha " kozott helykoz van
	}
return mut;
}


static void strlwr(char *mut)
{
while(*mut)
	{
	*mut = tolower(*mut);
	mut++;
	}
}



void htmfaveg(struct htmstr *gyoker)
{
int i,j;
struct nodestr *nodemut;
struct tagstr *tagmut;
struct szovegstr *szovmut;

for(i=0; i < gyoker->darab; i++)
	{
	nodemut = gyoker->ag[i];
	tagmut = nodemut->tag;
	if(tagmut != NULL)
		{	// html node
		for(j=0; i < tagmut->optszam; j++)
			{	// az opciok helyenek felszab.
			free(tagmut->optomb[j]->nev);
			free(tagmut->optomb[j]->opcio);
			}
		free(tagmut->optomb);
		if(tagmut->node != NULL && tagmut->node != gyoker)
			free(tagmut->node);
		free(tagmut);
		}
	else	{	// szoveg
		szovmut = nodemut->szov;
		for(j=0; j < szovmut->darab; j++)
			{
			free(szovmut->txt[j]->cim);
			}
		free(szovmut->txt);
		free(szovmut);
		}
	free(nodemut);
	}
}
