#include <stdio.h>
#include "htmlink.h"

//#define	DEBUG		// main(): HTML tag-ek es parametereik listaja

#define tagpar(nev)     nev[] =  #nev

// URI-t tartalmazo tag parameterek
const static char tagpar(action), tagpar(background),
	tagpar(cite), tagpar(classid), tagpar(codebase),
	tagpar(data),
	tagpar(href), tagpar(longdesc), tagpar(profile),
	tagpar(src),
	tagpar(usemap);

const static struct uristr tagok[] = {
	{ "a", 		{ href, NULL } },
	{ "applet",	{ codebase, NULL } },
	{ "area",	{ href, NULL } },
	{ "base",	{ href, NULL } },
	{ "blockquote",	{ cite, NULL } },
	{ "body",	{ background, NULL } },
	{ "del",	{ cite, NULL } },
	{ "form",	{ action, NULL } },
	{ "frame",	{ src, longdesc, NULL } },
	{ "head",	{ profile, NULL } },
	{ "iframe",	{ src, longdesc, NULL } },
	{ "img", 	{ src, longdesc, usemap, NULL } },
	{ "input",	{ src, usemap, NULL } },
	{ "ins",	{ cite, NULL } },
	{ "link",	{ href, NULL } },
	{ "object",	{ data, classid, codebase, usemap, NULL } },
	{ "q",		{ cite, NULL } },
	{ "script",	{ src, NULL } },
	};

const int tagszam = sizeof(tagok)/sizeof(struct uristr);

#ifdef	DEBUG

int main()
{
int i,n;

printf("%-15s" "URI-t tart. parameter(ek)\n"
"----------------------------------------\n","HTML tag");
for(n=0; n < tagszam; n++)
	{
	printf("%-15s%s",tagok[n].nev,tagok[n].param[0]);
	for(i=1; tagok[n].param[i] != NULL; i++)
		printf(", %s",tagok[n].param[i]);
	puts("");
	}
return(0);
}

#else

#include <stdlib.h>
#include <string.h>
#include "htmfa.h"

static int taghasonl(const char *,const struct uristr *);

static char sor[FILENAME_MAX], docroot[FILENAME_MAX];

int main(int argc, char *argv[])
{
int i;

// i = argc > 1? strlen(argv[1]): 0;
i = 0;		// a docroot megadasanak nincs ertelme az aliasok miatt
if(i >= sizeof(docroot))
	i = sizeof(docroot)-1;
if(i > 0)
	strncpy(docroot,argv[1],i);
docroot[i] = 0;
while(i > 0 && docroot[i-1] == '/')
	docroot[--i] = 0;
while(fgets(sor,sizeof(sor),stdin) != NULL)
	{
	strtok(sor,"\r\n");
	htmfa(sor);		// a file beolvasasa, HTML fa felepitese
	listfa(&gyoker,0);	// fa vegigjarasa. tagki-t es szovegki-t hivja, amit mi definialunk alabb
	htmfaveg(&gyoker);
	}
return(0);
}




void szovegki(struct szovegstr *tag,int szint) {}	// szoveget nem irunk ki


void tagki(struct tagstr *tag,int szint)		// a tag-et nem itt irjuk ki, hanem az opcioknal, ha kell
{
opcioki(tag,szint);
if(tag->node != NULL)		// a fa vegigjarasa rekurzivan
	listfa(tag->node,szint+1);
}



void opcioki(struct tagstr *tag,int szint)
{	// a fuggveny htmfa.h-ban van deklaralva, de csak tagki hivja
int i,j;// a szint parameter csak a htmfa.h-beli deklaracio miatt kell
struct uristr *mut;

mut = bsearch(tagtomb[tag->kod].nev,tagok,tagszam,sizeof(struct uristr),
	(int (*)(const void *, const void *))taghasonl);
if(mut == NULL)
	return;
for(i=0; i < tag->optszam; i++)
	{	// vegigmegyunk "tag" szovegben megadott opcioin
	for(j=0; mut->param[j] != NULL && j < sizeof(mut->param)/sizeof(char *); j++)
		{	// megnezzuk, hogy az opcio tartalma URI-e
		if(strcmp(mut->param[j],tag->optomb[i]->nev) == 0)
			{
			uriki(docroot,sor,tag->optomb[i]->opcio);
			printf("\t%s\n",sor);
			break;
			}
		}
	}
}


static int taghasonl(const char *tag,const struct uristr *tagmut)
{
return strcmp(tag,tagmut->nev);
}

#endif
