#include <stdio.h>	// libgyl miatt
#include <string.h>
//#include <libgyl.h>	// memicmp
#include "htmtree.h"

#define	taggen(par)	#par

const struct htagstr tagtomb[] = {
	{ taggen(a), {VAN}},			// 0
	{ taggen(abbr), {VAN}},
	{ taggen(acronym), {VAN}},
	{ taggen(address), {VAN}},
	{ taggen(applet), {VAN}},	// except PRE
	{ taggen(area), {NINCS}},
	{ taggen(b), {VAN}},		// all block & inline
	{ taggen(base), {NINCS}},
	{ taggen(basefont), {NINCS}},
	{ taggen(bdo), {VAN}},
	{ taggen(big), {VAN}},		// 10
	{ taggen(blockquote), {VAN}},
	{ taggen(body), {VAN}},
	{ taggen(br), {NINCS}},
	{ taggen(button), {VAN}},	// except BUTTON
	{ taggen(caption), {VAN}},
	{ taggen(center), {VAN}},
	{ taggen(cite), {VAN}},
	{ taggen(code), {VAN}},
	{ taggen(col), {NINCS}},
	{ taggen(colgroup), {VAN}},	// 20
	{ taggen(dd), {LEHET}},
	{ taggen(del), {VAN}},
	{ taggen(dfn), {VAN}},
	{ taggen(dir), {VAN}},
	{ taggen(div), {VAN}},
	{ taggen(dl), {VAN}},
	{ taggen(dt), {LEHET}},
	{ taggen(em), {VAN}},
	{ taggen(fieldset), {VAN}},
	{ taggen(font), {VAN}},		// 30
	{ taggen(form), {VAN}},
	{ taggen(frame), {NINCS}},
	{ taggen(frameset), {VAN}},
	{ taggen(h1), {VAN}},
	{ taggen(h2), {VAN}},
	{ taggen(h3), {VAN}},
	{ taggen(h4), {VAN}},
	{ taggen(h5), {VAN}},
	{ taggen(h6), {VAN}},
	{ taggen(head), {LEHET}},	// 40
	{ taggen(hr), {NINCS}},
	{ taggen(html), {VAN}},
	{ taggen(i), {VAN}},
	{ taggen(iframe), {VAN}},
	{ taggen(img), {NINCS}},
	{ taggen(input), {NINCS}},
	{ taggen(ins), {VAN}},
	{ taggen(isindex), {NINCS}},
	{ taggen(kbd), {VAN}},
	{ taggen(label), {VAN}},		// 50
	{ taggen(legend), {VAN}},
	{ taggen(li), {VAN}},
	{ taggen(link), {NINCS}},
	{ taggen(map), {VAN}},
	{ taggen(menu), {VAN}},
	{ taggen(meta), {NINCS}},
	{ taggen(noframes), {VAN}},
	{ taggen(noscript), {VAN}},
	{ taggen(object), {VAN}},
	{ taggen(ol), {VAN}},		// 60
	{ taggen(optgroup), {VAN}},
	{ taggen(option), {VAN}},
	{ taggen(p), {LEHET}},
	{ taggen(param), {NINCS}},
	{ taggen(pre), {VAN}},
	{ taggen(q), {VAN}},
	{ taggen(s), {VAN}},
	{ taggen(samp), {VAN}},
	{ taggen(script), {VAN}},
	{ taggen(select), {VAN}},	// 70
	{ taggen(small), {VAN}},
	{ taggen(span), {VAN}},
	{ taggen(strike), {VAN}},
	{ taggen(strong), {VAN}},
	{ taggen(style), {VAN}},
	{ taggen(sub), {VAN}},
	{ taggen(sup), {VAN}},
	{ taggen(table), {VAN}},
	{ taggen(tbody), {VAN}},
	{ taggen(td), {VAN}},		// 80
	{ taggen(textarea), {VAN}},
	{ taggen(tfoot), {VAN}},
	{ taggen(th), {VAN}},
	{ taggen(thead), {VAN}},
	{ taggen(title), {VAN}},
	{ taggen(tr), {VAN}},
	{ taggen(tt), {VAN}},
	{ taggen(u), {VAN}},
	{ taggen(ul), {VAN}},
	{ taggen(var), {VAN}},		// 90
	};
const int tagdarab = sizeof(tagtomb)/sizeof(struct htagstr);


enum htmlkod tagkeres(char **puffer)
{	// Ha talalt, puffer-t a tag utani karakterre allitja
char *mut;
const struct htagstr *tagmut;
int hossz;

mut = *puffer;
hossz = strcspn(mut," >");
for(tagmut=tagtomb; tagmut < tagtomb+tagdarab; tagmut++)
	{
//	if(memicmp(mut,tagmut->nev,hossz) == 0)
	if(strncasecmp(mut,tagmut->nev,hossz) == 0)
		{
		*puffer = mut + hossz;
		return(tagmut-tagtomb);
		}
	}
return(VEGE);
}
